Package org.apache.sysds.hops

# Class QuaternaryOp

java.lang.Object
org.apache.sysds.hops.Hop
org.apache.sysds.hops.MultiThreadedHop
org.apache.sysds.hops.QuaternaryOp

All Implemented Interfaces:
  `ParseInfo`

public class QuaternaryOp extends MultiThreadedHop
Note: this hop should be called AggQuaternaryOp in consistency with AggUnaryOp and AggBinaryOp; however, since there does not exist a real QuaternaryOp yet - we can leave it as is for now.

## Field Summary

Fields
Modifier and Type
Field
Description
`static boolean`
`FORCE_REPLICATION`

### Fields inherited from class org.apache.sysds.hops.Hop

`_beginColumn, _beginLine, _endColumn, _endLine, _filename, _text, CPThreshold`

## Constructor Summary

Constructors
Constructor
Description
`QuaternaryOp(String l, Types.DataType dt, Types.ValueType vt, Types.OpOp4 o, Hop inX, Hop inU, Hop inV)`
`QuaternaryOp(String l, Types.DataType dt, Types.ValueType vt, Types.OpOp4 o, Hop inX, Hop inU, Hop inV, boolean flag1, boolean flag2)`
Constructor for wsigmoid.
`QuaternaryOp(String l, Types.DataType dt, Types.ValueType vt, Types.OpOp4 o, Hop inW, Hop inU, Hop inV, boolean umult, Types.OpOp1 uop, Types.OpOp2 sop)`
`QuaternaryOp(String l, Types.DataType dt, Types.ValueType vt, Types.OpOp4 o, Hop inX, Hop inU, Hop inV, Hop inW, boolean post)`
Constructor for wsloss.
`QuaternaryOp(String l, Types.DataType dt, Types.ValueType vt, Types.OpOp4 o, Hop inX, Hop inU, Hop inV, Hop inW, int baseType, boolean flag1, boolean flag2)`

## Method Summary

Modifier and Type
Method
Description
`boolean`
`allowsAllExecTypes()`
`Object`
`clone()`
`boolean`
`compare(Hop that)`
`Lop`
`constructLops()`
`Types.OpOp4`
`getOp()`
`String`
`getOpString()`
`boolean`
`isGPUEnabled()`
In memory-based optimizer mode (see OptimizerUtils.isMemoryBasedOptLevel()), the exectype is determined by checking this method as well as memory budget of this Hop.
`boolean`
`isMultiThreadedOpType()`
`void`
`refreshSizeInformation()`
Update the output size information for this hop.

### Methods inherited from class org.apache.sysds.hops.MultiThreadedHop

`getMaxNumThreads, setMaxNumThreads`

### Methods inherited from class org.apache.sysds.hops.Hop

`activatePrefetch, addAllInputs, addInput, checkAndSetForcedPlatform, checkAndSetInvalidCPDimsAndSize, clearMemEstimate, colsKnown, compressedSize, computeBoundsInformation, computeBoundsInformation, computeBoundsInformation, computeMemEstimate, computeSizeInformation, computeSizeInformation, computeSizeInformation, constructAndSetLopsDataFlowProperties, createOffsetLop, deactivatePrefetch, dimsKnown, dimsKnown, dimsKnownAny, getBeginColumn, getBeginLine, getBlocksize, getCompressedSize, getDataCharacteristics, getDataType, getDim, getDim1, getDim2, getEndColumn, getEndLine, getExecType, getFederatedOutput, getFilename, getForcedExecType, getHopID, getInput, getInput, getInputMemEstimate, getInputMemEstimate, getInputOutputSize, getIntermediateMemEstimate, getLength, getLops, getMemEstimate, getName, getNnz, getOutputMemEstimate, getOutputMemEstimate, getParent, getSparsity, getSpBroadcastSize, getText, getUpdateType, getValueType, hasCompressedInput, hasFederatedOutput, hasLocalOutput, hasValidCPDimsAndSize, isCompressedOutput, isFederated, isFederatedDataOp, isMatrix, isMemEstimated, isOutputEmptyBlocks, isRequiredDecompression, isScalar, isTransposeSafe, isVisited, prefetchActivated, printErrorLocation, refreshColsParameterInformation, refreshColsParameterInformation, refreshMemEstimates, refreshRowsParameterInformation, refreshRowsParameterInformation, requiresCheckpoint, requiresCompression, requiresLineageCaching, requiresReblock, requiresRecompile, resetExecType, resetRecompilationFlag, resetRecompilationFlag, resetVisitStatus, resetVisitStatus, resetVisitStatus, resetVisitStatusForced, rowsKnown, setBeginColumn, setBeginLine, setBlocksize, setCompressedOutput, setCompressedSize, setDataType, setDim, setDim1, setDim2, setEndColumn, setEndLine, setExecType, setFederatedOutput, setFilename, setForcedExecType, setLops, setMemEstimate, setName, setNnz, setOutputEmptyBlocks, setParseInfo, setRequiresCheckpoint, setRequiresCompression, setRequiresCompression, setRequiresDeCompression, setRequiresLineageCaching, setRequiresReblock, setRequiresRecompile, setText, setUpdateType, setValueType, setVisited, setVisited, someInputFederated, toString, updateLopFedOut, updateLopFedOut`

### Methods inherited from class java.lang.Object

`equals, getClass, hashCode, notify, notifyAll, wait, wait, wait`

## Field Details

### FORCE_REPLICATION

public static boolean FORCE_REPLICATION

## Constructor Details

### QuaternaryOp

public QuaternaryOp(String l, Types.DataType dt, Types.ValueType vt, Types.OpOp4 o, Hop inX, Hop inU, Hop inV, Hop inW, boolean post)
Constructor for wsloss.

Parameters:
  `l` - ?
  `dt` - data type
  `vt` - value type
  `o` - the Hop.OpOp4
  `inX` - high-level operator X
  `inU` - high-level operator U
  `inV` - high-level operator V
  `inW` - high-level operator W
  `post` - post weights

### QuaternaryOp

public QuaternaryOp(String l, Types.DataType dt, Types.ValueType vt, Types.OpOp4 o, Hop inX, Hop inU, Hop inV, boolean flag1, boolean flag2)
Constructor for wsigmoid.

Parameters:
  `l` - ?
  `dt` - data type
  `vt` - value type
  `o` - the Hop.OpOp4
  `inX` - high-level operator X
  `inU` - high-level operator U
  `inV` - high-level operator V
  `flag1` - logout
  `flag2` - minusin

### QuaternaryOp

public QuaternaryOp(String l, Types.DataType dt, Types.ValueType vt, Types.OpOp4 o, Hop inX, Hop inU, Hop inV, Hop inW, int baseType, boolean flag1, boolean flag2)

### QuaternaryOp

public QuaternaryOp(String l, Types.DataType dt, Types.ValueType vt, Types.OpOp4 o, Hop inW, Hop inU, Hop inV, boolean umult, Types.OpOp1 uop, Types.OpOp2 sop)

### QuaternaryOp

public QuaternaryOp(String l, Types.DataType dt, Types.ValueType vt, Types.OpOp4 o, Hop inX, Hop inU, Hop inV)

## Method Details

### getOp

public Types.OpOp4 getOp()

### isGPUEnabled

public boolean isGPUEnabled()
Description copied from class: `Hop`
In memory-based optimizer mode (see OptimizerUtils.isMemoryBasedOptLevel()), the exectype is determined by checking this method as well as memory budget of this Hop. Please see findExecTypeByMemEstimate for more detail. This method is necessary because not all operator are supported efficiently on GPU (for example: operations on frames and scalar as well as operations such as table).

Specified by:
  `isGPUEnabled` in class `Hop`
Returns:
  true if the Hop is eligible for GPU Exectype.

### isMultiThreadedOpType

public boolean isMultiThreadedOpType()

Specified by:
  `isMultiThreadedOpType` in class `MultiThreadedHop`

### constructLops

public Lop constructLops()

Specified by:
  `constructLops` in class `Hop`

### getOpString

public String getOpString()

Specified by:
  `getOpString` in class `Hop`

### allowsAllExecTypes

public boolean allowsAllExecTypes()

Specified by:
  `allowsAllExecTypes` in class `Hop`

### refreshSizeInformation

public void refreshSizeInformation()
Description copied from class: `Hop`
Update the output size information for this hop.

Specified by:
  `refreshSizeInformation` in class `Hop`

### clone

public Object clone() throws CloneNotSupportedException

Specified by:
  `clone` in class `Hop`
Throws:
  `CloneNotSupportedException`

### compare

public boolean compare(Hop that)

Specified by:
  `compare` in class `Hop`